/***************************************************************************
 *   Copyright (C) 2003-2004 by Victor Julien                              *
 *   victor@nk.nl                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "main.h"


struct
{
	char	hostname[60];
//	char	connected;	/* connected to vuurmuur shm? 0: no, 1: yes */

} TopMenu;


static void
setup_topmenu(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);

	/* get the hostname */
	if(gethostname(TopMenu.hostname, sizeof(TopMenu.hostname)) < 0)
		strlcpy(TopMenu.hostname, "error", sizeof(TopMenu.hostname));

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE)|A_BOLD);
	mvwprintw(local_win, 0, (max_width - 4 - strlen(TopMenu.hostname)), " %s ", TopMenu.hostname);
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE)|A_BOLD);
}


void
draw_top_menu_main(const int debuglvl, WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	box(local_win, 0 , 0);
	mvwprintw(local_win, 0, 2, " Main Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "Welcome to the main menu, please make a selection.");
	mvwprintw(local_win, 1, (COLS-2-8), "F10 quit");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);

	wrefresh(local_win);

	return;
}


void
draw_top_menu_blocklist(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	box(local_win, 0 , 0);
	mvwprintw(local_win, 0, 2, " Block List ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "Here you can block ipaddresses, hosts and groups.");
	mvwprintw(local_win, 1, (COLS-2-8), "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);

	wrefresh(local_win);

	return;
}


void
draw_top_menu_services(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);

	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Services Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2,  "F12: help");
	mvwprintw(local_win, 1, 13, "INS: new");
	mvwprintw(local_win, 1, 24, "DEL: delete");
	mvwprintw(local_win, 1, 38, "ENTER: edit");
	mvwprintw(local_win, 1, COLS-16-2, "F10 back to Main");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);

	return;
}

void
draw_top_menu_edit_services(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Edit Services Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "F12:  help");
	mvwprintw(local_win, 1, COLS-20-2, "F10 back to Services");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);

	return;
}


void
draw_top_menu_interfaces(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Interfaces Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "F12: help  INS: new  DEL: del  RET: edit");
	mvwprintw(local_win, 1, COLS-8-2, "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);

	return;
}


void
draw_top_menu_edit_interface(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Edit Interface Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "F12: help  F5: advanced mode");
	mvwprintw(local_win, 1, COLS-8-2, "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);
	return;
}


void
draw_top_menu_zones(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Zones Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "F12: help  INS: new  DEL: del  RET: open, e: edit");
	mvwprintw(local_win, 1, COLS-8-2, "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);

	return;
}

void
draw_top_menu_editzones_group(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Edit Zones Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "F12: help  INS: new member");
	mvwprintw(local_win, 1, COLS-8-2, "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	wrefresh(local_win);
	return;
}

void
draw_top_menu_rules(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Rules Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "F12: help  INS: new  DEL: del  RET: edit  m: move  f: filter");
	mvwprintw(local_win, 1, COLS-8-2, "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);
	return;
}


void
draw_top_menu_edit_rule(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Edit Rule Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "F12: help  F5: advanced mode");
	mvwprintw(local_win, 1, COLS-8-2, "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);
	return;
}


void
draw_top_menu_logview(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Logview Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "s: search  f: filter  p: pause  c: clear  1-7: (un)hide colums");
	mvwprintw(local_win, 1, COLS-8-2, "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);
	return;
}

void
draw_top_menu_connections(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Connections Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "sort: u: grp unknown  i: in/out/fw  s: connect status  c: connect");
	mvwprintw(local_win, 1, COLS-8-2, "F10 back");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	setup_topmenu(local_win);
	wrefresh(local_win);

	return;
}

void
draw_top_menu_config(WINDOW *local_win)
{
	int	max_width, max_heigth;

	if(!local_win)
		return;

	getmaxyx(stdscr, max_heigth, max_width);
	werase(local_win);
	box(local_win, 0 , 0);

	wattron(local_win, COLOR_PAIR(CP_WHITE_BLUE));
	mvwprintw(local_win, 0, 2, " Edit Config Menu ");
	wattroff(local_win, COLOR_PAIR(CP_WHITE_BLUE));

	wattron(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);
	mvwprintw(local_win, 1, 2, "F12: help");
	mvwprintw(local_win, 1, COLS-16-2, "F10 back to Main");
	wattroff(local_win, COLOR_PAIR(CP_YELLOW_BLUE) | A_BOLD);

	wrefresh(local_win);
	return;
}
